/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	ContentsInfoCacher
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import jp.co.ntt.lms.lo.scorm.util.Debug;
import jp.co.ntt.lms.lo.scorm.util.SG;

import org.xml.sax.SAXException;

/**
 * ContentsInfoCacherクラス
 * コンテンツ情報キャッシュクラス
 */
public class ContentsInfoCacher implements Runnable {
	/** キャッシュの入れ物。セクション名がキーで値にHashMapが入る */
	private static HashMap cacheHolder = new HashMap();

	/** キャッシュの保持時間(msec) */
	private static long preserveTime;

	/** 唯一の自分自身 */
	private static ContentsInfoCacher self;

	/** キャッシュ破棄スレッド */
	private static Thread discarderThread;

	static {
		try {
			// SGからキャッシュ保持時間を取得する
			String value = SG.get("ContentsInfoCacheMinutes");

			// 取得できた場合はmsecに直し、プロパティへ設定する
			if (value != null) {
				try {
					preserveTime = Long.parseLong(value) * 60 * 1000;
				}
				catch (Exception ex) {
					Debug.write(ex);

					preserveTime = 0;
					ex.printStackTrace(System.out);
				}
			}

			// 自分自身を作成する
			new ContentsInfoCacher();
		}
		catch (Exception ex) {
			Debug.write(ex);

			preserveTime = 0;
			ex.printStackTrace(System.out);
		}
	}

	/**
	 * キャッシュが更新されたかどうかチェックを行う為のinterface
	 */
	public interface ValidateChecker {
		/**
		 * キャッシュが更新されたかどうかをチェックする
		 *
		 * @return キャッシュが有効な場合はtrueを、キャッシュが更新された場合はfalseを返却する
		 */
		boolean isValid();
	}

	/**
	 * ファイルが更新されたかどうかチェックを行う為のクラス
	 */
	public static class FileValidateChecker implements ValidateChecker {
		/** Fileオブジェクト */
		private File file;

		/** インスタンス生成時のファイル最終更新日付 */
		private long lastModified;

		/**
		 * デフォルトコンストラクタ
		 */
		private FileValidateChecker() {}

		/**
		 * コンストラクタ
		 *
		 * @param filename ファイル名を指定する
		 */
		public FileValidateChecker(String filename) {
			this.file = new File(filename);
			lastModified = file.lastModified();
		}

		/**
		 * ファイルが更新されたかどうかチェックする
		 *
		 * @return 更新された場合falseを、更新されていない場合はtrueを返却する
		 */
		public boolean isValid() {
			return (lastModified == file.lastModified());
		}
	}

	/**
	 * cacheHolderに格納するItem
	 */
	private static class CacheItem {
		/** 破棄時刻 */
		private long discardTime;

		/** キャッシュしているObject */
		private Object object;

		/** ValidateChecker */
		private ValidateChecker validateChecker;

		/**
		 * 破棄時刻を設定する
		 *
		 * @param discardTime	破棄時刻
		 */
		private void setDiscardTime(long discardTime) {
			this.discardTime = discardTime;
		}

		/**
		 * 破棄時刻を取得する
		 *
		 * @return 破棄時刻
		 */
		private long getDiscardTime() {
			return discardTime;
		}

		/**
		 * Objectを設定する
		 *
		 * @param object	Object
		 */
		private void setObject(Object object) {
			this.object = object;
		}

		/**
		 * Objectを取得する
		 *
		 * @return Object
		 */
		private Object getObject() {
			return object;
		}

		/**
		 * ValidateCheckerを取得する
		 *
		 * @return ValidateCheckerを返却する
		 */
		public ValidateChecker getValidateChecker() {
			return validateChecker;
		}

		/**
		 * ValidateCheckerを設定する
		 *
		 * @param validateChecker ValidateCheckerを指定する
		 */
		public void setValidateChecker(ValidateChecker validateChecker) {
			this.validateChecker = validateChecker;
		}
	}

	/**
	 * デフォルトコンストラクタ
	 */
	private ContentsInfoCacher() {
		if (preserveTime > 0) {
			self = this;

			discarderThread = new Thread(this);
			discarderThread.setDaemon(true);
			discarderThread.start();
		}
	}

	/**
	 * section及びkeyで指定された値をキャッシュから取得する<br>
	 * キャッシュに存在しない場合はnullを返却する
	 *
	 * @param section	セクション名
	 * @param key		キー名
	 * @return キャッシュしていたObjectを返却する。キャッシュが存在しなかった場合はnullを返却する
	 */
	public static Object get(String section, String key)
		throws IOException, ParserConfigurationException, SAXException, TransformerException {

		// cacheHolderからキャッシュを取得する
		if (preserveTime > 0) {
			synchronized (self) {
				HashMap sectionMap = (HashMap)cacheHolder.get(section);

				if (sectionMap != null) {
					CacheItem item = (CacheItem)sectionMap.get(key);

					// キャッシュされたitemが存在した場合
					if (item != null) {
						ValidateChecker validateChecker = item.getValidateChecker();

						if ((validateChecker == null) || (validateChecker.isValid())) {
							// キャッシュ破棄時刻を設定する
							item.setDiscardTime(System.currentTimeMillis() + preserveTime);

							// キャッシュ破棄スレッドにキャッシュの更新を通知する
							self.notify();

							// 取得できたitemに設定されているObjectを返却する
							return item.getObject();
						}

						// キャッシュ破棄時刻を0に設定し、破棄を行う
						item.setDiscardTime(0);

						// キャッシュ破棄スレッドにキャッシュの更新を通知する
						self.notify();

						// 取得できたitemに設定されているObjectを返却する
						return null;
					}
				}
			}
		}

		return null;
	}

	/**
	 * section及びkeyでobjectをキャッシュに設定する
	 *
	 * @param section	セクション名
	 * @param key		キー名
	 * @param object	キャッシュするObject
	 */
	public static void set(String section, String key, Object object, ValidateChecker validateChecker) {
		if (preserveTime > 0) {
			synchronized (self) {
				HashMap sectionMap = (HashMap)cacheHolder.get(section);

				if (sectionMap == null) {
					sectionMap = new HashMap();
					cacheHolder.put(section, sectionMap);
				}

				CacheItem item = new CacheItem();

				item.setObject(object);
				item.setDiscardTime(key.equals("") ? Long.MAX_VALUE : (System.currentTimeMillis() + preserveTime));
				item.setValidateChecker(validateChecker);

				sectionMap.put(key, item);

				self.notify();
			}
		}
	}

	/**
	 * キャッシュ破棄スレッド<br>
	 * SGで指定された時間が過ぎてアクセスが行われなかったCachedItemをcacheHolderから取り除く
	 */
	public void run() {
		try {
			ArrayList discardItems = new ArrayList();
			long wackupMillis;

			synchronized (self) {
				while (true) {
					wackupMillis = Long.MAX_VALUE;

					// キャッシュを全て更新し、破棄時刻を過ぎているItemのリストを作成する
					for (Iterator sections = cacheHolder.keySet().iterator(); sections.hasNext();) {
						HashMap sectionMap = (HashMap)cacheHolder.get(sections.next());

						for (Iterator keys = sectionMap.keySet().iterator(); keys.hasNext();) {
							Object key = keys.next();

							CacheItem item = (CacheItem)sectionMap.get(key);

							if (item.getDiscardTime() <= System.currentTimeMillis()) {
								discardItems.add(key);
							}
							else {
								if (item.getDiscardTime() < wackupMillis) {
									wackupMillis = item.getDiscardTime();
								}
							}
						}

						// 破棄時刻を過ぎているItemをキャッシュから削除する
						for (int i = 0; i < discardItems.size(); i++) {
							sectionMap.remove(discardItems.get(i));
						}

						discardItems.clear();
					}

					// 次の破棄イベントが発生するまで待機する
					if (wackupMillis >= Long.MAX_VALUE) {
						self.wait();
					}
					else {
						wackupMillis -= System.currentTimeMillis();

						if (wackupMillis > 0) {
							self.wait(wackupMillis);
						}
					}
				}
			}
		}
		catch (Exception ex) {
			Debug.write(ex);

			ex.printStackTrace(System.out);
		}
	}
}
